﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using CommonBehaviors.Actions;
namespace FarmMage
{
    public class Main : CombatRoutine
    {
        public override string Name { get { return "Mage Farm Routine by Pasterke"; } }
        public override WoWClass Class { get { return WoWClass.Mage; } }
        public static LocalPlayer Me { get { return StyxWoW.Me; } }


        public override bool NeedRest
        {
            get
            {
                if (Me.HasAura("Food") || Me.HasAura("Drink")) return false;
                if (Me.ManaPercent <= 50) { Styx.CommonBot.Rest.Feed(); }
                return false;
            }
        }

        public override void Pull()
        {
            if (Me.HasAura("Food") || Me.HasAura("Drink")) return;
            if (Me.CurrentTarget != null && (Me.CurrentTarget.Distance > 39 || !Me.CurrentTarget.InLineOfSight))
            {
                Navigator.MoveTo(Me.CurrentTarget.Location);
            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.Distance <= 39 && Me.CurrentTarget.InLineOfSight)
            {
                Navigator.PlayerMover.MoveStop();
            }
            if (Me.CurrentTarget != null && !Me.IsSafelyFacing(Me.CurrentTarget))
            {
                Me.CurrentTarget.Face();
            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.Distance <= 40 && Me.CurrentTarget.InLineOfSight && SpellManager.CanCast("Ice Lance"))
            {
                SpellManager.Cast("Ice Lance", Me.CurrentTarget);
            }
        }

        public override bool NeedPreCombatBuffs
        {
            get
            {
                if (Me.HasAura("Arcane Brilliance")) return false;
                if (!Me.HasAura("Arcane Brilliance")) SpellManager.Cast("Arcane Brilliance", Me);
                return false;
            }
        }

        public override void Combat()
        {
            if (Me.HasAura("Food") || Me.HasAura("Drink")) return;
            if (Me.Mounted) return;
            if (Me.CurrentTarget != null && (Me.CurrentTarget.Distance > 39 || !Me.CurrentTarget.InLineOfSight))
            {
                Navigator.MoveTo(Me.CurrentTarget.Location);
            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.Distance <= 39 && Me.CurrentTarget.InLineOfSight)
            {
                Navigator.PlayerMover.MoveStop();
            }
            if (Me.CurrentTarget != null && !Me.IsSafelyFacing(Me.CurrentTarget))
            {
                Me.CurrentTarget.Face();
            }
            if (Me.CurrentTarget != null
                && AddCount >= 3
                && SpellManager.HasSpell("Blizzard")
                && SpellManager.CanCast("Blizzard"))
            {
                SpellManager.Cast("Blizzard");
                SpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
            }
            if (Me.CurrentTarget != null 
                && Me.CurrentTarget.IsValid 
                && Me.CurrentTarget.Attackable 
                && Me.CurrentTarget.InLineOfSight 
                && !Me.CurrentTarget.IsFriendly
                && SpellManager.CanCast("Ice Lance"))
            {
                SpellManager.Cast("Ice Lance", Me.CurrentTarget);
            }
        }

        public int AddCount
        {
            get
            {
                return ObjectManager.GetObjectsOfTypeFast<WoWUnit>().Count(p => p.IsAlive
                    && p.Distance <= 35
                    && p.Combat
                    && p.IsTargetingMeOrPet);
            }
        }

    }
}
